commit:     24c2c7655e0800006754698e54505ad99ff3290e
Author:     Alexey Sokolov <alexey+gentoo <AT> asokolov <DOT> org>
AuthorDate: Fri Apr  4 21:47:19 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Apr 28 20:42:00 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=24c2c765

dev-cpp/cpp-httplib: fix dependency on zstd for users of library

Closes: https://bugs.gentoo.org/953066
Signed-off-by: Alexey Sokolov <alexey+gentoo <AT> asokolov.org>
Part-of: https://github.com/gentoo/gentoo/pull/41458
Signed-off-by: Sam James <sam <AT> gentoo.org>

 dev-cpp/cpp-httplib/cpp-httplib-0.20.0-r1.ebuild   | 106 +++++++++++++++++++++
 .../files/cpp-httplib-0.20.0-zstd2.patch           |  32 +++++++
 2 files changed, 138 insertions(+)

diff --git a/dev-cpp/cpp-httplib/cpp-httplib-0.20.0-r1.ebuild 
b/dev-cpp/cpp-httplib/cpp-httplib-0.20.0-r1.ebuild
new file mode 100644
index 000000000000..95a963ba30a2
--- /dev/null
+++ b/dev-cpp/cpp-httplib/cpp-httplib-0.20.0-r1.ebuild
@@ -0,0 +1,106 @@
+# Copyright 2022-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{11..13} )
+
+inherit cmake-multilib python-any-r1 toolchain-funcs
+
+DESCRIPTION="C++ HTTP/HTTPS server and client library"
+HOMEPAGE="https://github.com/yhirose/cpp-httplib/";
+
+if [[ "${PV}" == *9999* ]] ; then
+       inherit git-r3
+
+       EGIT_REPO_URI="https://github.com/yhirose/${PN}.git";
+else
+       SRC_URI="https://github.com/yhirose/${PN}/archive/v${PV}.tar.gz
+               -> ${P}.tar.gz"
+
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86"
+fi
+
+LICENSE="MIT"
+SLOT="0/0.20"  # soversion / /usr/include/httplib.h: CPPHTTPLIB_VERSION
+
+IUSE="brotli ssl test zlib zstd"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+       brotli? (
+               app-arch/brotli:=[${MULTILIB_USEDEP}]
+       )
+       ssl? (
+               >=dev-libs/openssl-3.0.13:=[${MULTILIB_USEDEP}]
+       )
+       zlib? (
+               sys-libs/zlib[${MULTILIB_USEDEP}]
+       )
+       zstd? (
+               app-arch/zstd[${MULTILIB_USEDEP}]
+       )
+"
+DEPEND="
+       ${RDEPEND}
+"
+BDEPEND="
+       ${PYTHON_DEPS}
+       virtual/pkgconfig
+"
+
+PATCHES=(
+       "${FILESDIR}/${P}-zstd.patch"
+       "${FILESDIR}/${P}-zstd2.patch"
+)
+
+src_configure() {
+       local -a mycmakeargs=(
+               -DHTTPLIB_COMPILE=yes
+               -DBUILD_SHARED_LIBS=yes
+               -DHTTPLIB_USE_BROTLI_IF_AVAILABLE=no
+               -DHTTPLIB_USE_OPENSSL_IF_AVAILABLE=no
+               -DHTTPLIB_USE_ZLIB_IF_AVAILABLE=no
+               -DHTTPLIB_USE_ZSTD_IF_AVAILABLE=no
+               -DHTTPLIB_REQUIRE_BROTLI=$(usex brotli)
+               -DHTTPLIB_REQUIRE_OPENSSL=$(usex ssl)
+               -DHTTPLIB_REQUIRE_ZLIB=$(usex zlib)
+               -DHTTPLIB_REQUIRE_ZSTD=$(usex zstd)
+               -DPython3_EXECUTABLE="${PYTHON}"
+       )
+       cmake-multilib_src_configure
+}
+
+multilib_src_test() {
+       cp -p -R --reflink=auto "${S}/test" ./test || die
+
+       local -a failing_tests=(
+               # Disable all online tests.
+               "*.*_Online"
+
+               # Fails on musl x86:
+               ServerTest.GetRangeWithMaxLongLength
+               ServerTest.GetStreamedWithTooManyRanges
+
+               # https://github.com/yhirose/cpp-httplib/issues/1798
+               # Filed by mgorny's testing, fails on openssl >=3.2:
+               SSLClientServerTest.ClientCertPresent
+               SSLClientServerTest.ClientEncryptedCertPresent
+               SSLClientServerTest.CustomizeServerSSLCtx
+               SSLClientServerTest.MemoryClientCertPresent
+               SSLClientServerTest.MemoryClientEncryptedCertPresent
+               SSLClientServerTest.TrustDirOptional
+
+               # https://github.com/yhirose/cpp-httplib/issues/2113
+               MaxTimeoutTest.ContentStream
+               MaxTimeoutTest.ContentStreamSSL
+       )
+
+       # Little dance to please the GTEST filter (join array using ":").
+       failing_tests_str="${failing_tests[@]}"
+       failing_tests_filter="${failing_tests_str// /:}"
+
+       # PREFIX is . to avoid calling "brew" and relying on stuff in /opt
+       GTEST_FILTER="-${failing_tests_filter}" emake -C test \
+               CXX="$(tc-getCXX)" CXXFLAGS="${CXXFLAGS} -I." PREFIX=.
+}

diff --git a/dev-cpp/cpp-httplib/files/cpp-httplib-0.20.0-zstd2.patch 
b/dev-cpp/cpp-httplib/files/cpp-httplib-0.20.0-zstd2.patch
new file mode 100644
index 000000000000..73f33e64268f
--- /dev/null
+++ b/dev-cpp/cpp-httplib/files/cpp-httplib-0.20.0-zstd2.patch
@@ -0,0 +1,32 @@
+https://bugs.gentoo.org/953066
+https://github.com/yhirose/cpp-httplib/pull/2126
+
+--- a/cmake/httplibConfig.cmake.in
++++ b/cmake/httplibConfig.cmake.in
+@@ -39,7 +39,25 @@ if(@HTTPLIB_IS_USING_BROTLI@)
+ endif()
+ 
+ if(@HTTPLIB_IS_USING_ZSTD@)
+-      find_dependency(zstd)
++      set(httplib_fd_zstd_quiet_arg)
++      if(${CMAKE_FIND_PACKAGE_NAME}_FIND_QUIETLY)
++              set(httplib_fd_zstd_quiet_arg QUIET)
++      endif()
++      set(httplib_fd_zstd_required_arg)
++      if(${CMAKE_FIND_PACKAGE_NAME}_FIND_REQUIRED)
++              set(httplib_fd_zstd_required_arg REQUIRED)
++      endif()
++      find_package(zstd QUIET)
++      if(NOT zstd_FOUND)
++              find_package(PkgConfig ${httplib_fd_zstd_quiet_arg} 
${httplib_fd_zstd_required_arg})
++              if(PKG_CONFIG_FOUND)
++                      pkg_check_modules(zstd ${httplib_fd_zstd_quiet_arg} 
${httplib_fd_zstd_required_arg} IMPORTED_TARGET libzstd)
++
++                      if(TARGET PkgConfig::zstd)
++                              add_library(zstd::libzstd ALIAS PkgConfig::zstd)
++                      endif()
++              endif()
++      endif()
+       set(httplib_zstd_FOUND ${zstd_FOUND})
+ endif()
+ 

Reply via email to